var fs = require("fs");
global.logger = console;

var ClientProxy = require("../lib/ClientProxy.js");
var clientProxy = new ClientProxy();
var channelName ="main1"; //'channel_' + Math.floor(Date.now() / 1000);

var channelConfigPath="C:\\Users\\QKLJF\\Desktop\\channel02.tx";


var targetObj = {
  peer_url : ['grpcs://peer0.platform.bankalliance.org:7051'],
  orderer_url : 'grpcs://orderer0.bankalliance.org:7050',
  event_url : 'grpcs://peer0.platform.bankalliance.org:7053'
};

var certificate = `-----BEGIN CERTIFICATE-----
MIICOTCCAd+gAwIBAgIQOX9lpS/X0pSamLoKDGWUATAKBggqhkjOPQQDAjB/MQsw
CQYDVQQGEwJDTjESMBAGA1UECBMJZ3Vhbmdkb25nMREwDwYDVQQHEwhzaGVuemhl
bjEiMCAGA1UEChMZcGxhdGZvcm0uYmFua2FsbGlhbmNlLm9yZzElMCMGA1UEAxMc
Y2EucGxhdGZvcm0uYmFua2FsbGlhbmNlLm9yZzAeFw0xODA5MTkxMzA5MTRaFw0y
ODA5MTYxMzA5MTRaMG8xCzAJBgNVBAYTAkNOMRIwEAYDVQQIEwlndWFuZ2Rvbmcx
ETAPBgNVBAcTCHNoZW56aGVuMQ8wDQYDVQQLEwZjbGllbnQxKDAmBgNVBAMMH0Fk
bWluQHBsYXRmb3JtLmJhbmthbGxpYW5jZS5vcmcwWTATBgcqhkjOPQIBBggqhkjO
PQMBBwNCAASfzeQe4P119qtZLCvW4U0dklyWSDYFWu7E2xte+02P4Jj+EcEqD+RH
NHPgIEEDR4Y3Uv0GCq+kYPt5I9CZIsRWo00wSzAOBgNVHQ8BAf8EBAMCB4AwDAYD
VR0TAQH/BAIwADArBgNVHSMEJDAigCAlAHXV08uwGXy6cYljtLmNHX6uijbq6ymR
2cvazo4pcTAKBggqhkjOPQQDAgNIADBFAiEA5woj3PG2E11xjkrebQY4xnxNq6he
na5Xg4Gq1gafa5wCICKypuUxafdMOlEoCO8ZSnbM+P2D2r54dx37QCPM6ewM
-----END CERTIFICATE-----
`;

var private_key = `-----BEGIN PRIVATE KEY-----
MIGHAgEAMBMGByqGSM49AgEGCCqGSM49AwEHBG0wawIBAQQgiFmlxXnRvB3otNtC
EPYVySXMoDxT0JwpfHOZtOJH5oOhRANCAASfzeQe4P119qtZLCvW4U0dklyWSDYF
Wu7E2xte+02P4Jj+EcEqD+RHNHPgIEEDR4Y3Uv0GCq+kYPt5I9CZIsRW
-----END PRIVATE KEY-----
`;


var orderer_opts = {
  pem: `-----BEGIN CERTIFICATE-----
MIICPTCCAeSgAwIBAgIRAP0eBcrG0hY6RkldTWDbGzEwCgYIKoZIzj0EAwIwcDEL
MAkGA1UEBhMCQ04xEjAQBgNVBAgTCWd1YW5nZG9uZzERMA8GA1UEBxMIc2hlbnpo
ZW4xGTAXBgNVBAoTEGJhbmthbGxpYW5jZS5vcmcxHzAdBgNVBAMTFnRsc2NhLmJh
bmthbGxpYW5jZS5vcmcwHhcNMTgwOTE5MTMwOTE1WhcNMjgwOTE2MTMwOTE1WjBw
MQswCQYDVQQGEwJDTjESMBAGA1UECBMJZ3Vhbmdkb25nMREwDwYDVQQHEwhzaGVu
emhlbjEZMBcGA1UEChMQYmFua2FsbGlhbmNlLm9yZzEfMB0GA1UEAxMWdGxzY2Eu
YmFua2FsbGlhbmNlLm9yZzBZMBMGByqGSM49AgEGCCqGSM49AwEHA0IABHAkTu6O
gn49yRFz8dR81WGlWiDEpmmu1CuzUvtk+Q5fUTDvpQQKGcHnkhDHGQfLXRN+9QEa
msWJ7oQO6YkdAU6jXzBdMA4GA1UdDwEB/wQEAwIBpjAPBgNVHSUECDAGBgRVHSUA
MA8GA1UdEwEB/wQFMAMBAf8wKQYDVR0OBCIEIF3zrholATtsoNUvG/5OtKy18604
cGjUUtVJd4PUtCjMMAoGCCqGSM49BAMCA0cAMEQCICXeROFCLRhceGCEl47niNFr
ypziNPNWa2rP0foXEm4LAiBBu0kAftOHD4vGD2PdVrqgtmBwj0kmD2IwnuKW74sS
pg==
-----END CERTIFICATE-----`
};
clientProxy.setClientSigningIdentity(private_key, certificate, 'Org0MSP');

describe('=== ClientProxy Channel TestCase ===', function () {
  it("--- createChannel ---", function (done) {
    clientProxy.createChannelByFile(targetObj.orderer_url, channelName, fs.readFileSync(channelConfigPath),orderer_opts)
      .then(function (result) {
        console.log("createChannel Result:", result);
        done()
      })
      .catch(function (err) {
        console.error(err);
        done()
      })
  });
});


