var assert = require("assert");
var util = require('util')
var should = require('should');
var Promise = require('bluebird')

global.logger = console

var ClientProxy = require("../lib/ClientProxy.js");

var timeStamp = Math.floor(Date.now()/1000);

var clientProxy = new ClientProxy()

var channelName = 'main' 
var chaincodeName = 'mycc'
var fcn = 'wCreate'
var args = ['{"tokenId":"T'+timeStamp+'","owner":"深圳区块链金融服务有限公司","type":"DEBIT_RECEIVE","balance":10000000.80,"createTime":'+timeStamp+'}']

var targetObj = {
  peer_url : ['grpcs://123.206.193.147:7051'],
  orderer_url : 'grpcs://123.206.193.147:7050',
  event_url : null//'grpc://123.206.193.147:7053'
}



var certificate = `-----BEGIN CERTIFICATE-----
MIICRjCCAe2gAwIBAgIRAJiSiRUs1nVonhLjJFCWdYcwCgYIKoZIzj0EAwIwgYUx
CzAJBgNVBAYTAlVTMRMwEQYDVQQIEwpDYWxpZm9ybmlhMRYwFAYDVQQHEw1TYW4g
RnJhbmNpc2NvMSIwIAYDVQQKExlwbGF0Zm9ybS5iYW5rYWxsaWFuY2Uub3JnMSUw
IwYDVQQDExxjYS5wbGF0Zm9ybS5iYW5rYWxsaWFuY2Uub3JnMB4XDTE4MDcyNTEy
MjExN1oXDTI4MDcyMjEyMjExN1owdTELMAkGA1UEBhMCVVMxEzARBgNVBAgTCkNh
bGlmb3JuaWExFjAUBgNVBAcTDVNhbiBGcmFuY2lzY28xDzANBgNVBAsTBmNsaWVu
dDEoMCYGA1UEAwwfVXNlcjFAcGxhdGZvcm0uYmFua2FsbGlhbmNlLm9yZzBZMBMG
ByqGSM49AgEGCCqGSM49AwEHA0IABPcG51jHod4IZp7Qq5T9LQNWzDO/yuwPeNek
PtMizCx8/c86MGZDER262MwPf3BuMR+mIxxr6WoOfJAf88oENKGjTTBLMA4GA1Ud
DwEB/wQEAwIHgDAMBgNVHRMBAf8EAjAAMCsGA1UdIwQkMCKAINUvyagKffbk0F0D
IwHv1ZTaIloZPu4b5LAVKKSARUrdMAoGCCqGSM49BAMCA0cAMEQCIAbql1WLRFk+
WylSAFECImdcK+dTzbfYP8Mxw1dkQKBIAiAs5P29aFSocZNJecF489Zp9shwG9JQ
C1fSiJZeQQNosQ==
-----END CERTIFICATE-----`

var private_key = `-----BEGIN PRIVATE KEY-----
MIGHAgEAMBMGByqGSM49AgEGCCqGSM49AwEHBG0wawIBAQQgCm62ACfPPUEnBJDm
4THlImfCpCc/VNcXT1nb+YmgLZOhRANCAAT3BudYx6HeCGae0KuU/S0DVswzv8rs
D3jXpD7TIswsfP3POjBmQxEdutjMD39wbjEfpiMca+lqDnyQH/PKBDSh
-----END PRIVATE KEY-----`

clientProxy.setClientSigningIdentity(private_key,certificate,'platformMSP')

describe('=== ClientProxy TestCase ===', function(){

  it("--- invokeChaincode ---",function(done){
    clientProxy.invokeChaincode(targetObj,channelName,chaincodeName,fcn,args)
    .then(function(result){
      console.log("invoke_result=",result)
      done()
    })
    .catch(function(err){
      console.error(err)
      done()
    })

  });
});


