var assert = require("assert");
var util = require('util')
var should = require('should');
var Promise = require('bluebird')
var fs = require('fs')

global.logger = console

var grpc = require('grpc');
var _commonProto = grpc.load('lib/protos/common/common.proto').common;
var _configtxProto = grpc.load('lib/protos/common/configtx.proto').common;
var _configurationProto = grpc.load('lib/protos/common/configuration.proto').common;

// console.log('_commonProto=',_commonProto)


describe('=== Proto Decode TestCase ===', function(){

  it("--- channel_config_envelope ---",function(done){
    
    let config_envelope = fs.readFileSync('test/mainChannel.tx');
    var envelope = _commonProto.Envelope.decode(config_envelope);
    var payload = _commonProto.Payload.decode(envelope.payload);
    var configtx = _configtxProto.ConfigUpdateEnvelope.decode(payload.data);
    var config_update = _configtxProto.ConfigUpdate.decode(configtx.config_update);
   /* var config_update_object = _configtxProto.ConfigUpdate.encodeJSON(config_update, {
        longs: String,
        enums: String,
        bytes: String,
        // see ConversionOptions
    });*/

/*    console.log('envelope=',envelope)
    console.log('configtx=',configtx)
    console.log('config_update=',config_update.encodeJSON())*/
    console.log('config_update=',config_update.encodeJSON())
    console.log(config_update.write_set.values.map.Consortium.v)
    var consortium = _configurationProto.Consortium.decode(config_update.write_set.values.map.Consortium.value.value);
    console.log(consortium.encodeJSON())

    done()
  });
});


